#include "SevenSegment.h"

/**
 * @brief Constructor
 * @param pinEcho the echo pin
 * @param pinTrigger the trigger pin
 */
SevenSegment::SevenSegment(int pinA, int pinB, int pinC, int pinD, int pinE, int pinF, int pinG, int pinDP, bool isCommonAnode)
{
  this->pinA  = pinA;
  this->pinB  = pinB;
  this->pinC  = pinC;
  this->pinD  = pinD;
  this->pinE  = pinE;
  this->pinF  = pinF;
  this->pinG  = pinG;
  this->pinDP = pinDP;
  this->isCommonAnode = isCommonAnode;

  if(isCommonAnode){
    LEDON  = LOW;
    LEDOFF = HIGH;
  }
  else{
    LEDON  = HIGH;
    LEDOFF = LOW;
  }
     
  
  pinMode(pinA, OUTPUT);
  pinMode(pinB, OUTPUT);
  pinMode(pinC, OUTPUT);
  pinMode(pinD, OUTPUT);
  pinMode(pinE, OUTPUT);
  pinMode(pinF, OUTPUT);
  pinMode(pinG, OUTPUT);
  pinMode(pinDP, OUTPUT);
}

/**
 * @brief This method is used to print the number 1
 */
void SevenSegment::Print1()
{
  digitalWrite(pinA,  LEDOFF); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDOFF); 
  digitalWrite(pinE,  LEDOFF); 
  digitalWrite(pinF,  LEDOFF); 
  digitalWrite(pinG,  LEDOFF); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 2
 */
void SevenSegment::Print2()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDOFF); 
  digitalWrite(pinD,  LEDON); 
  digitalWrite(pinE,  LEDON); 
  digitalWrite(pinF,  LEDOFF); 
  digitalWrite(pinG,  LEDON); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 3
 */
void SevenSegment::Print3()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDON); 
  digitalWrite(pinE,  LEDOFF); 
  digitalWrite(pinF,  LEDOFF); 
  digitalWrite(pinG,  LEDON); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 4
 */
void SevenSegment::Print4()
{
  digitalWrite(pinA,  LEDOFF); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDOFF); 
  digitalWrite(pinE,  LEDOFF); 
  digitalWrite(pinF,  LEDON); 
  digitalWrite(pinG,  LEDON); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 5
 */
void SevenSegment::Print5()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDOFF); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDON); 
  digitalWrite(pinE,  LEDOFF); 
  digitalWrite(pinF,  LEDON); 
  digitalWrite(pinG,  LEDON); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 6
 */
void SevenSegment::Print6()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDOFF); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDON); 
  digitalWrite(pinE,  LEDON); 
  digitalWrite(pinF,  LEDON); 
  digitalWrite(pinG,  LEDON); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 7
 */
void SevenSegment::Print7()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDOFF); 
  digitalWrite(pinE,  LEDOFF); 
  digitalWrite(pinF,  LEDOFF); 
  digitalWrite(pinG,  LEDOFF); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 8
 */
void SevenSegment::Print8()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDON); 
  digitalWrite(pinE,  LEDON); 
  digitalWrite(pinF,  LEDON); 
  digitalWrite(pinG,  LEDON); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 9
 */
void SevenSegment::Print9()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDOFF); 
  digitalWrite(pinE,  LEDOFF); 
  digitalWrite(pinF,  LEDON); 
  digitalWrite(pinG,  LEDON); 
  digitalWrite(pinDP, LEDOFF);   
}

/**
 * @brief This method is used to print the number 0
 */
void SevenSegment::Print0()
{
  digitalWrite(pinA,  LEDON); 
  digitalWrite(pinB,  LEDON); 
  digitalWrite(pinC,  LEDON); 
  digitalWrite(pinD,  LEDON); 
  digitalWrite(pinE,  LEDON); 
  digitalWrite(pinF,  LEDON); 
  digitalWrite(pinG,  LEDOFF); 
  digitalWrite(pinDP, LEDOFF);   
}


void SevenSegment::CountDown(int delayTime)
{
  Print9();
  delay(delayTime);
  Print8();
  delay(delayTime);
  Print7();
  delay(delayTime);
  Print6();
  delay(delayTime);
  Print5();
  delay(delayTime);
  Print4();
  delay(delayTime);
  Print3();
  delay(delayTime);
  Print2();
  delay(delayTime);
  Print1();
  delay(delayTime);
  Print0();
  delay(delayTime);
}
  
  
