#ifndef SEVENSEGMENT_H
#define SEVENSEGMENT_H

#include "Arduino.h"

/**
 * @brief This class allows to manage the Seven Segment Display.
 * @author Andrea Primavera.
 * @version 1.0
 * @date 2021/03/29
 */
 class SevenSegment
{

  private:
    int pinA;
    int pinB;
    int pinC;
    int pinD;
    int pinE;
    int pinF;
    int pinG;
    int pinDP;
    bool isCommonAnode;

    int LEDON;
    int LEDOFF;

  public:
    SevenSegment(int pinA, int pinB, int pinC, int pinD, int pinE, int pinF, int pinG, int pinDP, bool isCommonAnode);

    void Print0();
    void Print1();
    void Print2();
    void Print3();
    void Print4();
    void Print5();
    void Print6();
    void Print7();
    void Print8();
    void Print9(); 

    void CountDown(int delayTime);
};

#endif
